package net.mcreator.gts.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Checkbox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.gts.world.inventory.TokiConfigMenu1Menu;
import net.mcreator.gts.procedures.CheckDisableVoreProcedure;
import net.mcreator.gts.procedures.CheckDisableUpperBreachProcedure;
import net.mcreator.gts.procedures.CheckDisableTrappedBreachProcedure;
import net.mcreator.gts.procedures.CheckDisableThrowProcedure;
import net.mcreator.gts.procedures.CheckDisableSubmissionProcedure;
import net.mcreator.gts.procedures.CheckDisableStepProcedure;
import net.mcreator.gts.procedures.CheckDisableSpitProcedure;
import net.mcreator.gts.procedures.CheckDisableSniperProcedure;
import net.mcreator.gts.procedures.CheckDisableSitProcedure;
import net.mcreator.gts.procedures.CheckDisableShowOffProcedure;
import net.mcreator.gts.procedures.CheckDisableMiddleBreachProcedure;
import net.mcreator.gts.procedures.CheckDisableLowerBreachProcedure;
import net.mcreator.gts.procedures.CheckDisableKickProcedure;
import net.mcreator.gts.procedures.CheckDisableGunSmashProcedure;
import net.mcreator.gts.procedures.CheckDisableGunSlapProcedure;
import net.mcreator.gts.procedures.CheckDisableDroneProcedure;
import net.mcreator.gts.network.TokiConfigMenu1ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class TokiConfigMenu1Screen extends AbstractContainerScreen<TokiConfigMenu1Menu> {
	private final static HashMap<String, Object> guistate = TokiConfigMenu1Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Checkbox StepDisable;
	Checkbox KickDisable;
	Checkbox SitDisable;
	Checkbox DisableGunSlap;
	Checkbox DisableGunSmash;
	Checkbox DisableThrow;
	Checkbox DisableVore;
	Checkbox DisableSniper;
	Checkbox DisableSpit;
	Checkbox DisableDrone;
	Checkbox DisableUpperBreach;
	Checkbox DisableMiddleBreach;
	Checkbox DisableLowerBreach;
	Checkbox DisableTrappedBreach;
	Checkbox DisableCelebration;
	Checkbox DisableSubmission;
	Button button_nextpage;

	public TokiConfigMenu1Screen(TokiConfigMenu1Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 400;
		this.imageHeight = 200;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("gts:textures/screens/toki_config_menu_1.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.toki_config_menu_1.label_check_to_disable"), 6, 7, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.toki_config_menu_1.label_tokis_attack"), 6, 23, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.toki_config_menu_1.label_tokis_breach"), 6, 98, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.gts.toki_config_menu_1.label_tokis_behavior"), 6, 138, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_nextpage = Button.builder(Component.translatable("gui.gts.toki_config_menu_1.button_nextpage"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new TokiConfigMenu1ButtonMessage(0, x, y, z));
				TokiConfigMenu1ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 324, this.topPos + 10, 67, 20).build();
		guistate.put("button:button_nextpage", button_nextpage);
		this.addRenderableWidget(button_nextpage);
		StepDisable = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.StepDisable"), this.font).pos(this.leftPos + 9, this.topPos + 39).selected(CheckDisableStepProcedure.execute(world)).build();
		guistate.put("checkbox:StepDisable", StepDisable);
		this.addRenderableWidget(StepDisable);
		KickDisable = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.KickDisable"), this.font).pos(this.leftPos + 67, this.topPos + 39).selected(CheckDisableKickProcedure.execute(world)).build();
		guistate.put("checkbox:KickDisable", KickDisable);
		this.addRenderableWidget(KickDisable);
		SitDisable = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.SitDisable"), this.font).pos(this.leftPos + 127, this.topPos + 39).selected(CheckDisableSitProcedure.execute(world)).build();
		guistate.put("checkbox:SitDisable", SitDisable);
		this.addRenderableWidget(SitDisable);
		DisableGunSlap = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableGunSlap"), this.font).pos(this.leftPos + 219, this.topPos + 39).selected(CheckDisableGunSlapProcedure.execute(world)).build();
		guistate.put("checkbox:DisableGunSlap", DisableGunSlap);
		this.addRenderableWidget(DisableGunSlap);
		DisableGunSmash = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableGunSmash"), this.font).pos(this.leftPos + 303, this.topPos + 39).selected(CheckDisableGunSmashProcedure.execute(world)).build();
		guistate.put("checkbox:DisableGunSmash", DisableGunSmash);
		this.addRenderableWidget(DisableGunSmash);
		DisableThrow = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableThrow"), this.font).pos(this.leftPos + 9, this.topPos + 73).selected(CheckDisableThrowProcedure.execute(world)).build();
		guistate.put("checkbox:DisableThrow", DisableThrow);
		this.addRenderableWidget(DisableThrow);
		DisableVore = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableVore"), this.font).pos(this.leftPos + 72, this.topPos + 73).selected(CheckDisableVoreProcedure.execute(world)).build();
		guistate.put("checkbox:DisableVore", DisableVore);
		this.addRenderableWidget(DisableVore);
		DisableSniper = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableSniper"), this.font).pos(this.leftPos + 127, this.topPos + 73).selected(CheckDisableSniperProcedure.execute(world)).build();
		guistate.put("checkbox:DisableSniper", DisableSniper);
		this.addRenderableWidget(DisableSniper);
		DisableSpit = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableSpit"), this.font).pos(this.leftPos + 237, this.topPos + 73).selected(CheckDisableSpitProcedure.execute(world)).build();
		guistate.put("checkbox:DisableSpit", DisableSpit);
		this.addRenderableWidget(DisableSpit);
		DisableDrone = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableDrone"), this.font).pos(this.leftPos + 298, this.topPos + 73).selected(CheckDisableDroneProcedure.execute(world)).build();
		guistate.put("checkbox:DisableDrone", DisableDrone);
		this.addRenderableWidget(DisableDrone);
		DisableUpperBreach = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableUpperBreach"), this.font).pos(this.leftPos + 9, this.topPos + 113).selected(CheckDisableUpperBreachProcedure.execute(world)).build();
		guistate.put("checkbox:DisableUpperBreach", DisableUpperBreach);
		this.addRenderableWidget(DisableUpperBreach);
		DisableMiddleBreach = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableMiddleBreach"), this.font).pos(this.leftPos + 100, this.topPos + 113).selected(CheckDisableMiddleBreachProcedure.execute(world)).build();
		guistate.put("checkbox:DisableMiddleBreach", DisableMiddleBreach);
		this.addRenderableWidget(DisableMiddleBreach);
		DisableLowerBreach = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableLowerBreach"), this.font).pos(this.leftPos + 197, this.topPos + 113).selected(CheckDisableLowerBreachProcedure.execute(world)).build();
		guistate.put("checkbox:DisableLowerBreach", DisableLowerBreach);
		this.addRenderableWidget(DisableLowerBreach);
		DisableTrappedBreach = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableTrappedBreach"), this.font).pos(this.leftPos + 288, this.topPos + 113).selected(CheckDisableTrappedBreachProcedure.execute(world)).build();
		guistate.put("checkbox:DisableTrappedBreach", DisableTrappedBreach);
		this.addRenderableWidget(DisableTrappedBreach);
		DisableCelebration = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableCelebration"), this.font).pos(this.leftPos + 8, this.topPos + 151).selected(CheckDisableShowOffProcedure.execute(world)).build();
		guistate.put("checkbox:DisableCelebration", DisableCelebration);
		this.addRenderableWidget(DisableCelebration);
		DisableSubmission = Checkbox.builder(Component.translatable("gui.gts.toki_config_menu_1.DisableSubmission"), this.font).pos(this.leftPos + 160, this.topPos + 151).selected(CheckDisableSubmissionProcedure.execute(world)).build();
		guistate.put("checkbox:DisableSubmission", DisableSubmission);
		this.addRenderableWidget(DisableSubmission);
	}
}
