package net.mcreator.gts.procedures;

import net.neoforged.neoforge.event.entity.EntityLeaveLevelEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.Event;

import net.minecraft.world.scores.PlayerTeam;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.Entity;
import net.minecraft.tags.TagKey;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.registries.Registries;

import javax.annotation.Nullable;

@EventBusSubscriber
public class GtsLeftWorldProcedure {
	@SubscribeEvent
	public static void onEntityLeft(EntityLeaveLevelEvent event) {
		execute(event, event.getLevel(), event.getEntity());
	}

	public static void execute(LevelAccessor world, Entity entity) {
		execute(null, world, entity);
	}

	private static void execute(@Nullable Event event, LevelAccessor world, Entity entity) {
		if (entity == null)
			return;
		if (entity.getType().is(TagKey.create(Registries.ENTITY_TYPE, ResourceLocation.parse("gts:giantess"))) && !world.isClientSide()) {
			if (entity.getRemovalReason() == Entity.RemovalReason.DISCARDED || entity.getRemovalReason() == Entity.RemovalReason.KILLED) {
				if (world instanceof Level _level) {
					PlayerTeam _pt = _level.getScoreboard().getPlayerTeam((entity.getStringUUID()));
					if (_pt != null)
						_level.getScoreboard().removePlayerTeam(_pt);
				}
			}
		}
	}
}
